<?php

namespace app\models\mikrotik\mpls\mpls;

use yii\base\Model;
use Yii;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use PEAR2\Net\RouterOS;
use app\models\mikrotik\MikrotikConnect;

class Remotebinding extends Model {

    public $id;
    public $dst_address;
    public $label;
    public $nexthop;
    public $dynamic;
    public $disabled;

    public function rules() {
        return [
            ['id', 'string'],
            ['dst_address', 'string'],
            ['label', 'string'],
            ['nexthop', 'string'],
            ['dynamic', 'string'],
            ['disabled', 'string'],
        ];
    }

    public function getAll() {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/mpls/remote-bindings/getall');
        $responses = $connect->getConnection()->sendSync($getRequest);
        $return = array();
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $c = new Remotebinding();
                $c->id = $response->getProperty('.id');
                $c->dst_address = $response->getProperty('dst-address');
                $c->label = $response->getProperty('label');
                $c->dynamic = $response->getProperty('dynamic');
                $c->nexthop = $response->getProperty('nexthop');
                $c->disabled = $response->getProperty('disabled');
                $return[] = $c;
            }
        }
        return $return;
    }

    public function get($id) {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/mpls/remote-bindings/print');
        $getRequest->setQuery(RouterOS\Query::where('.id', $id));
        $responses = $connect->getConnection()->sendSync($getRequest);
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $this->id = $response->getProperty('.id');
                $this->dst_address = $response->getProperty('dst-address');
                $this->label = $response->getProperty('label');
                $this->nexthop = $response->getProperty('nexthop');
                $this->dynamic = (($response->getProperty('dynamic') == 'true') ? true : false);
                $this->disabled = (($response->getProperty('disabled') == 'true') ? true : false);
            }
        }
        return;
    }

    public function update($id) {
        $c = new Remotebinding();
        $c->get($id);
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/remote-bindings/set');
        $setRequest->setargument('.id', $id);
        if ($this->dst_address != $c->dst_address) {
            $setRequest->setargument('dst-address', $this->dst_address);
        }
        if ($this->label != $c->label) {
            $setRequest->setargument('label', $this->label);
        }
        if ($this->nexthop != $c->nexthop) {
            $setRequest->setargument('nexthop', $this->nexthop);
        }
        if (isset($unset)) {
            $unsetRequest = new RouterOS\Request('/mpls/remote-bindings/unset');
            foreach ($unset as $value) {
                $unsetRequest->setArgument('.id', $id);
                $unsetRequest->setArgument('value-name', $value);
                $resp = $connect->getConnection()->sendSync($unsetRequest);
                if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
                    if (!isset($re)) {
                        $re = '';
                    } $re.= ' ' . $resp->getProperty('message');
                }
            }
        } $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            if (isset($re)) {
                $re.= ' ' . $resp->getProperty('message');
            } else {
                $re = $resp->getProperty('message');
            }
        } if (isset($re)) {
            return $re;
        } else {
            return '1';
        }
    }

    public function disable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/remote-bindings/disable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function enable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/remote-bindings/enable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function create() {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/remote-bindings/add');
        if ($this->nexthop != "") {
            $setRequest->setargument('nexthop', $this->nexthop);
        }
        if ($this->dst_address != "") {
            $setRequest->setargument('dst-address', $this->dst_address);
        }
        if ($this->label != "") {
            $setRequest->setargument('label', $this->label);
        }

        $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            return $resp->getProperty('message');
        } else {
            return '1';
        }
    }

    public function delete($id) {
        $connect = MikrotikConnect::Instance();
        $util = new RouterOS\Util($connect->getConnection());
        $util->setMenu('/mpls/remote-bindings');
        $util->remove(RouterOS\Query::where('.id', $id));
        return;
    }

}
